'From Squeak3.8.1 of ''28 Aug 2006'' [latest update: #6747] on 11 January 2010 at 9:50:22 pm'!

!AsynchFilePlugin methodsFor: 'primitives' stamp: 'John M McIntosh 12/1/2009 21:42'!
primitiveAsyncFileOpen: fileName forWrite: writeFlag semaIndex: semaIndex 
	| fileNameSize fOop f okToOpen |
	self var: #f type: 'AsyncFile *'.
	self var: #f type: 'AsyncFile *'.
	self primitive: 'primitiveAsyncFileOpen' parameters: #(#String #Boolean #SmallInteger ).
	fileNameSize := interpreterProxy slotSizeOf: (fileName asOop: String).
	"If the security plugin can be loaded, use it to check for permission.
	If not, assume it's ok"
	sCOAFfn ~= 0
		ifTrue: [okToOpen := self cCode: ' ((sqInt (*) (char *, sqInt, sqInt)) sCOAFfn)(fileName, fileNameSize, writeFlag)'.
			okToOpen ifFalse: [^ interpreterProxy primitiveFail]].
	fOop := interpreterProxy instantiateClass: interpreterProxy classByteArray indexableSize: (self cCode: 'sizeof(AsyncFile)').
	f := self asyncFileValueOf: fOop.
	interpreterProxy failed ifFalse: [self cCode: 'asyncFileOpen(f, fileName, fileNameSize, writeFlag, semaIndex)'].
	^ fOop! !


!FT2Plugin methodsFor: 'private' stamp: 'John M McIntosh 12/25/2009 14:10'!
ftEncodingValueFromString: string
	"Return a 32-bit word from the bytes held by string."
	| ptr retval |
	self returnTypeC: 'FT_Encoding'.
	self var: #ptr type: 'unsigned char*'.
	self var: #retval type: 'unsigned long'.
	interpreterProxy success:
		((interpreterProxy isIntegerObject: string) not and:
		 [(interpreterProxy isBytes: string) and:
		 [(interpreterProxy slotSizeOf: string) = (self cCode: 'sizeof(FT_Encoding)')]]).
	interpreterProxy failed ifTrue: [ ^nil ].

	retval := 0.
	ptr := interpreterProxy arrayValueOf: string.
	
	"	ptr := self cCode: '(unsigned char *) (string + 4)'."

	self touch: ptr.

	retval := self cCode: '((unsigned long)ptr[0]) << 24'.
	self cCode: 'retval += ((unsigned long)ptr[1]) << 16'.
	self cCode: 'retval += ((unsigned long)ptr[2]) << 8'.
	self cCode: 'retval += (unsigned long)ptr[3]'.
	self touch: retval.

	^self cCode: '(FT_Encoding)retval'.
! !

!FT2Plugin methodsFor: 'private' stamp: 'John M McIntosh 12/20/2009 17:21'!
ftHandleValueFromReceiver: rcvrOop
	"this is the opposite of #ftAllocateHandleIn:forPointer: .
	It takes rcvr's first instance variable,
	which should be a ByteArray the size of a void*,
	and returns its value as a C pointer."

	| oop btw |
	self inline: false.

	self returnTypeC: 'void *'.
	oop := interpreterProxy fetchPointer: 0 ofObject: rcvrOop.
	
	interpreterProxy success:
		((interpreterProxy isBytes: oop) and:
		 [(interpreterProxy slotSizeOf: oop) = (self cCode: 'sizeof(void *)')]).
	interpreterProxy failed ifTrue: [^ nil].
	btw := self bytesPerWord.
	^self cCode:  '*(void**)(pointerForOop(oop + btw))'.
! !

!FT2Plugin methodsFor: 'initialize' stamp: 'John M McIntosh 12/25/2009 14:32'!
primitiveNewFaceFromFile: fontFilePath index: anInteger  
	"Fill in the receiver's (a FT2Face object) fields
	from the address and fields of a newly opened FT_Face object."

	| rcvr face byteSize translatedFilePath |
	rcvr := self primitive: 'primitiveNewFaceFromFileAndIndex'
		parameters: #(String SmallInteger)
		receiver: #FT2Face.
	self touch: rcvr.

	self var: #face type: 'FT_Face'.	"a pointer"
	self var: #byteSize type: 'size_t'.
	self var: #translatedFilePath declareC: 'char translatedFilePath[1024]'.
	
	errorCode := 0.

	byteSize := interpreterProxy byteSizeOf: fontFilePath cPtrAsOop.
	self touch: byteSize.
	interpreterProxy failed ifTrue: [ ^nil ].

	byteSize > 1000 ifTrue: 
		[interpreterProxy success: 0.
		^nil].
	interpreterProxy ioFilename: translatedFilePath fromString: fontFilePath ofLength: byteSize resolveAliases: true.

	errorCode := self cCode: 'FT_New_Face(library, translatedFilePath, anInteger, &face)' 
					 inSmalltalk: [ 1000 ].
	self cCode: '' inSmalltalk: [ face := face ].
	self touch: face.

	interpreterProxy success: errorCode == 0.
	interpreterProxy failed ifTrue: [ ^nil ].

	self ftAllocateHandleInReceiverForPointer: face.
! !

!FT2Plugin methodsFor: 'primitives-FT2Face' stamp: 'John M McIntosh 12/25/2009 19:20'!
primitiveSetTransform: matrixWordArray delta: deltaWordArray
	| face rcvr matrix delta deltasqIntPtr matrixsqIntPtr |
	self var: #face declareC: 'FT_Face face'.
	self var: #matrix declareC: 'FT_Matrix matrix'.
	self var: #matrixsqIntPtr declareC: 'sqInt *matrixsqIntPtr'.
	self var: #delta declareC: 'FT_Vector delta'.
	self var: #deltasqIntPtr  declareC: 'sqInt *deltasqIntPtr'.

	rcvr := self 
				primitive: 'primitiveSetTransform'
				parameters: #(Oop Oop)
				receiver: #FT2Face.
	face := self ftHandleValueFromReceiver: rcvr.
	face isNil ifTrue: [^interpreterProxy primitiveFail].
	matrixsqIntPtr := interpreterProxy arrayValueOf: matrixWordArray.
	deltasqIntPtr := interpreterProxy arrayValueOf: deltaWordArray.
	self cCode: 'delta.x = deltasqIntPtr[0]; delta.y = deltasqIntPtr[1];'.
	self cCode: 'matrix.xx = matrixsqIntPtr[0]; matrix.xy = matrixsqIntPtr[1]; 
		matrix.yx = matrixsqIntPtr[2]; matrix.yy = matrixsqIntPtr[3]; '.
	interpreterProxy failed
		ifFalse:[
			self cCode: 'FT_Set_Transform( face, &matrix, &delta)' inSmalltalk: [
				self touch: matrix.
				self touch: delta]].
! !

!FT2Plugin methodsFor: 'primitives-FT2Face' stamp: 'John M McIntosh 12/25/2009 19:20'!
primitiveTransformFaceGlyphSlotOutline: matrixWordArray

	| face matrix rcvr matrixsqIntPtr |
	self var: #face declareC: 'FT_Face face'.
	self var: #matrix declareC: 'FT_Matrix matrix'.
	self var: #matrixsqIntPtr declareC: 'sqInt *matrixsqIntPtr'.
	rcvr := self 
				primitive: 'primitiveTransformFaceGlyphSlotOutline'
				parameters: #(Oop)
				receiver: #FT2Face.
	face := self ftHandleValueFromReceiver: rcvr.
	face isNil ifTrue: [^interpreterProxy primitiveFail].
	matrixsqIntPtr := interpreterProxy arrayValueOf: matrixWordArray.
	self cCode: 'matrix.xx = matrixsqIntPtr[0]; matrix.xy = matrixsqIntPtr[1]; 
		matrix.yx = matrixsqIntPtr[2]; matrix.yy = matrixsqIntPtr[3]; '.
	interpreterProxy failed
		ifFalse:[
			self cCode: 'FT_Outline_Transform( &face->glyph->outline, &matrix )'  inSmalltalk: [
				self touch: matrix]]
	! !

!FT2Plugin methodsFor: 'primitives-FT2Face' stamp: 'John M McIntosh 12/25/2009 18:40'!
primitiveTranslateFaceGlyphSlotOutline: deltaWordArray

	| face delta rcvr deltasqIntPtr |
	self var: #face declareC: 'FT_Face face'.
	self var: #delta declareC: 'FT_Vector delta'.
	self var: #deltasqIntPtr  declareC: 'sqInt *deltasqIntPtr'.
	rcvr := self 
				primitive: 'primitiveTranslateFaceGlyphSlotOutline'
				parameters: #(Oop)
				receiver: #FT2Face.
	face := self ftHandleValueFromReceiver: rcvr.
	face isNil ifTrue: [^interpreterProxy primitiveFail].
	deltasqIntPtr := interpreterProxy arrayValueOf: deltaWordArray.
	self cCode: 'delta.x = deltasqIntPtr[0]; delta.y = deltasqIntPtr[1];'.
	interpreterProxy failed
		ifFalse:[
			self cCode: 'FT_Outline_Translate( &face->glyph->outline, delta.x, delta.y )'  inSmalltalk: [
				self touch: delta]]
	! !

!FT2Plugin methodsFor: 'primitives-FT2GlyphSlot' stamp: 'John M McIntosh 12/20/2009 17:44'!
primitiveGetPostscriptName
	"return a String"

	| face rcvr string buffer |
	self var: #face type: 'FT_Face'.	"ptr to struct"
	self var: #buffer type: 'char*'.
	rcvr := self 
				primitive: 'primitiveGetPostscriptName'
				parameters: #()
				receiver: #FT2Face.
	buffer := 0.
	face := self ftHandleValueFromReceiver: rcvr.
	face isNil ifTrue: [^interpreterProxy primitiveFail].
	self cCode: 'buffer = FT_Get_Postscript_Name(face)'.
	interpreterProxy success: buffer ~= 0.  
	interpreterProxy failed ifTrue: [^nil].
	string := self ftAllocateStringForPointer: buffer.
	^string! !

!FT2Plugin methodsFor: 'primitives-FT2GlyphSlot' stamp: 'John M McIntosh 12/20/2009 17:59'!
primitiveLoadGlyphSlotFrom: aFace 
	"Assumes that primitiveLoadGlyph:flags: has been called earlier to set face->glyph."

	| rcvr face gfOop gfPtr gs btw |
	self var: #face type: 'FT_Face'.	"ptr to struct"
	self var: #gs declareC: 'FT_GlyphSlot gs'.	"ptr to struct"
	self var: #gfPtr declareC: 'FT_Glyph_Format *gfPtr'.
	rcvr := self 
				primitive: 'primitiveLoadGlyphSlotFromFace'
				parameters: #(#FT2Face)
				receiver: #FT2GlyphSlot.
	errorCode := 0.
	(interpreterProxy slotSizeOf: rcvr) < 8 
		ifTrue: [^interpreterProxy primitiveFail].
	face := self ftHandleValueFromReceiver: aFace.
	face isNil ifTrue: [^interpreterProxy primitiveFail].
	gs := self cCode: 'face->glyph'.
	gs ifFalse: [^interpreterProxy primitiveFail].
	self touch: gs.

	"face 0"
	interpreterProxy 
		storePointer: 0
		ofObject: rcvr
		withValue: aFace.

	"linearHorizontalAdvance 1"
	interpreterProxy 
		storeInteger: 1
		ofObject: rcvr
		withValue: (self cCode: 'gs->linearHoriAdvance').

	"linearVerticalAdvance 2"
	interpreterProxy 
		storeInteger: 2
		ofObject: rcvr
		withValue: (self cCode: 'gs->linearVertAdvance').

	"advanceX 3"
	interpreterProxy 
		storeInteger: 3
		ofObject: rcvr
		withValue: (self cCode: 'gs->advance.x').

	"advanceY 4"
	interpreterProxy 
		storeInteger: 4
		ofObject: rcvr
		withValue: (self cCode: 'gs->advance.y').

	"format 5"
	interpreterProxy pushRemappableOop: rcvr.
	gfOop := interpreterProxy 
				instantiateClass: interpreterProxy classByteArray
				indexableSize: (self cCode: 'sizeof(FT_Glyph_Format)').
	self touch: gfOop.
	btw := self bytesPerWord.
	gfPtr := self cCode: '(FT_Glyph_Format *) pointerForOop(gfOop + btw)'.
	self touch: gfPtr.
	interpreterProxy failed ifTrue: [^nil].
	self cCode: '*gfPtr = gs->format'.
	rcvr := interpreterProxy popRemappableOop.
	interpreterProxy 
		storePointer: 5
		ofObject: rcvr
		withValue: gfOop.

	"bitmapLeft 6"
	interpreterProxy 
		storeInteger: 6
		ofObject: rcvr
		withValue: (self cCode: 'gs->bitmap_left').

	"bitmapTop 7"
	interpreterProxy 
		storeInteger: 7
		ofObject: rcvr
		withValue: (self cCode: 'gs->bitmap_top').

	"width 8"
	interpreterProxy 
		storeInteger: 8
		ofObject: rcvr
		withValue: (self cCode: 'gs->metrics.width').

	"height 9"
	interpreterProxy 
		storeInteger: 9
		ofObject: rcvr
		withValue: (self cCode: 'gs->metrics.height').

	"hBearingX 10"
	interpreterProxy 
		storeInteger: 10
		ofObject: rcvr
		withValue: (self cCode: 'gs->metrics.horiBearingX').

	"hBearingY 11"
	interpreterProxy 
		storeInteger: 11
		ofObject: rcvr
		withValue: (self cCode: 'gs->metrics.horiBearingY').

	"hAdvance 12"
	interpreterProxy 
		storeInteger: 12
		ofObject: rcvr
		withValue: (self cCode: 'gs->metrics.horiAdvance').

	"vBearingX 13"
	interpreterProxy 
		storeInteger: 13
		ofObject: rcvr
		withValue: (self cCode: 'gs->metrics.vertBearingX').

	"vBearingY 14"
	interpreterProxy 
		storeInteger: 14
		ofObject: rcvr
		withValue: (self cCode: 'gs->metrics.vertBearingY').

	"vAdvance 15"
	interpreterProxy 
		storeInteger: 15
		ofObject: rcvr
		withValue: (self cCode: 'gs->metrics.vertAdvance')! !


!HostWindowPlugin methodsFor: 'system primitives' stamp: 'John M McIntosh 12/1/2009 21:44'!
primitiveShowHostWindow: windowIndex bits: dispBits width: w height: h depth: d
left: left right: right top: top bottom: bottom
"Host window analogue of DisplayScreen> primShowRectLeft:right:top:bottom:
(Interpreter>primitiveShowDisplayRect) which takes the window index, bitmap
details and the rectangle bounds. Fail if the windowIndex is invalid or the
platform routine returns false to indicate failure"
	|ok|
	self var: #dispBits type: 'unsigned char * '.
	self primitive: 'primitiveShowHostWindowRect'
		parameters: #(SmallInteger WordArray SmallInteger SmallInteger SmallInteger
SmallInteger SmallInteger SmallInteger SmallInteger).

	"Tell the vm to copy pixel's from dispBits to the screen - this is just
ioShowDisplay with the extra parameter of the windowIndex integer"
	ok := self cCode: 'ioShowDisplayOnWindow(dispBits, w, h, d, left, right, top,
bottom, windowIndex)'.
	ok ifFalse:[interpreterProxy primitiveFail]! !


!JPEGReadWriter2Plugin methodsFor: 'primitives' stamp: 'John M McIntosh 1/4/2010 00:12'!
primJPEGReadImage: aJPEGDecompressStruct fromByteArray: source onForm: form doDithering: ditherFlag errorMgr: aJPEGErrorMgr2Struct

	| pcinfo pjerr buffer rowStride formBits formDepth i j formPix ok rOff gOff bOff rOff2 gOff2 bOff2 formWidth formHeight pixPerWord formPitch formBitsSize sourceSize r1 r2 g1 g2 b1 b2 formBitsOops dmv1 dmv2 di dmi dmo |
	self export: true.

	self
		primitive: 'primJPEGReadImagefromByteArrayonFormdoDitheringerrorMgr'
		parameters: #(ByteArray ByteArray Form Boolean ByteArray).

 	self var: #pcinfo type: 'j_decompress_ptr '.
 	self var: #pjerr type: 'error_ptr2 '.
	self var: #buffer type: 'JSAMPARRAY '.
	self var: #formBits type: 'unsigned * '.

	"Avoid warnings when saving method"
	 pcinfo := nil. pjerr := nil. buffer := nil. rowStride := nil.
		formDepth := nil. formBits := nil. i := nil. j := nil. formPix := nil.
		ok := nil. rOff := nil. gOff := nil. bOff := nil. rOff2 := nil. gOff2 := nil. bOff2 := nil. sourceSize := nil.
		r1 := nil. r2 := nil. g1 := nil. g2 := nil. b1 := nil. b2 := nil.
		dmv1 := nil. dmv2 := nil. di := nil. dmi := nil. dmo := nil.
		pcinfo. pjerr. buffer. rowStride. formBits. formDepth. i. j. formPix. ok.
		rOff. gOff. bOff. rOff2. gOff2. bOff2. sourceSize.
		r1. r2. g1.g2. b1. b2. dmv1. dmv2. di. dmi. dmo.

	formBitsOops := interpreterProxy fetchPointer: 0 ofObject: form.
	formDepth := interpreterProxy fetchInteger: 3 ofObject: form.

	"Various parameter checks"
	self cCode: '
		interpreterProxy->success
			((interpreterProxy->stSizeOf(interpreterProxy->stackValue(4))) >= (sizeof(struct jpeg_decompress_struct)));
		interpreterProxy->success
			((interpreterProxy->stSizeOf(interpreterProxy->stackValue(0))) >= (sizeof(struct error_mgr2))); 
		if (interpreterProxy->failed()) return null;
	' inSmalltalk: [].
	formWidth := (self cCode: '((j_decompress_ptr)aJPEGDecompressStruct)->image_width' inSmalltalk: [0]).
	formHeight := (self cCode: '((j_decompress_ptr)aJPEGDecompressStruct)->image_height' inSmalltalk: [0]).
	pixPerWord := 32 // formDepth.
	formPitch := formWidth + (pixPerWord-1) // pixPerWord * 4.
	formBitsSize := interpreterProxy byteSizeOf: formBitsOops.
	interpreterProxy success: 
		((interpreterProxy isWordsOrBytes: formBitsOops)
			and: [formBitsSize = (formPitch * formHeight)]).
	interpreterProxy failed ifTrue: [^ nil].
	formBits := interpreterProxy firstIndexableField: formBitsOops.

	self cCode: '
		sourceSize = interpreterProxy->stSizeOf(interpreterProxy->stackValue(3));
		if (sourceSize == 0) {
			interpreterProxy->success(false);
			return null;
		}
		pcinfo = (j_decompress_ptr)aJPEGDecompressStruct;
		pjerr = (error_ptr2)aJPEGErrorMgr2Struct;
		pcinfo->err = jpeg_std_error(&pjerr->pub);
		pjerr->pub.error_exit = error_exit;
		ok = 1;
		if (setjmp(pjerr->setjmp_buffer)) {
			jpeg_destroy_decompress(pcinfo);
			ok = 0;
		}
		if (ok) {
			ok = jpeg_mem_src_newLocationOfData(pcinfo, source, sourceSize);
			if (ok) {
				/* Dither Matrix taken from Form>>orderedDither32To16, but rewritten for this method. */
				int ditherMatrix1[] = { 2, 0, 14, 12, 1, 3, 13, 15 };
				int ditherMatrix2[] = { 10, 8, 6, 4, 9, 11, 5, 7 };
 				jpeg_start_decompress(pcinfo);
				rowStride = pcinfo->output_width * pcinfo->output_components;
				if (pcinfo->out_color_components == 3) {
					rOff = 0; gOff = 1; bOff = 2;
					rOff2 = 3; gOff2 = 4; bOff2 = 5;
				} else {
					rOff = 0; gOff = 0; bOff = 0;
					rOff2 = 1; gOff2 = 1; bOff2 = 1;
				}
				/* Make a one-row-high sample array that will go away when done with image */
				buffer = (*(pcinfo->mem)->alloc_sarray)
					((j_common_ptr) pcinfo, JPOOL_IMAGE, rowStride, 1);

				/* Step 6: while (scan lines remain to be read) */
				/*           jpeg_read_scanlines(...); */

				/* Here we use the library state variable cinfo.output_scanline as the
				 * loop counter, so that we dont have to keep track ourselves.
				 */
				while (pcinfo->output_scanline < pcinfo->output_height) {
					/* jpeg_read_scanlines expects an array of pointers to scanlines.
					 * Here the array is only one element long, but you could ask for
					 * more than one scanline at a time if thats more convenient.
					 */
					(void) jpeg_read_scanlines(pcinfo, buffer, 1);

					switch (formDepth) {
						case 32:
							for(i = 0, j = 1; i < rowStride; i +=(pcinfo->out_color_components), j++) {
								formPix = (255 << 24) | (buffer[0][i+rOff] << 16) | (buffer[0][i+gOff] << 8) | buffer[0][i+bOff];
								if (formPix == 0) formPix = 1;
								formBits [ ((pcinfo->output_scanline - 1) * (pcinfo->image_width)) + j ] = formPix;
							}
							break;

						case 16:
							for(i = 0, j = 1; i < rowStride; i +=(pcinfo->out_color_components*2), j++) {
								r1 = buffer[0][i+rOff];
								r2 = buffer[0][i+rOff2];
								g1 = buffer[0][i+gOff];
								g2 = buffer[0][i+gOff2];
								b1 = buffer[0][i+bOff];
								b2 = buffer[0][i+bOff2];

								if (!!ditherFlag) {
									r1 = r1 >> 3;
									r2 = r2 >> 3;
									g1 = g1 >> 3;
									g2 = g2 >> 3;
									b1 = b1 >> 3;
									b2 = b2 >> 3;
								} else {
									/* Do 4x4 ordered dithering. Taken from Form>>orderedDither32To16 */
									dmv1 = ditherMatrix1[ ((pcinfo->output_scanline & 3 )<< 1) | (j&1) ];
									dmv2 = ditherMatrix2[ ((pcinfo->output_scanline & 3 )<< 1) | (j&1) ];

									di = (r1 * 496) >> 8; dmi = di & 15; dmo = di >> 4;
									if(dmv1 < dmi) { r1 = dmo+1; } else { r1 = dmo; };
									di = (g1 * 496) >> 8; dmi = di & 15; dmo = di >> 4;
									if(dmv1 < dmi) { g1 = dmo+1; } else { g1 = dmo; };
									di = (b1 * 496) >> 8; dmi = di & 15; dmo = di >> 4;
									if(dmv1 < dmi) { b1 = dmo+1; } else { b1 = dmo; };

									di = (r2 * 496) >> 8; dmi = di & 15; dmo = di >> 4;
									if(dmv2 < dmi) { r2 = dmo+1; } else { r2 = dmo; };
									di = (g2 * 496) >> 8; dmi = di & 15; dmo = di >> 4;
									if(dmv2 < dmi) { g2 = dmo+1; } else { g2 = dmo; };
									di = (b2 * 496) >> 8; dmi = di & 15; dmo = di >> 4;
									if(dmv2 < dmi) { b2 = dmo+1; } else { b2 = dmo; };
								}

								formPix = (r1 << 10) | (g1 << 5) | b1;
								if (!!formPix) formPix = 1;
								formPix = (formPix << 16) | (r2 << 10) | (g2 << 5) | b2;
								if (!!(formPix & 65535)) formPix = formPix | 1;
								formBits [ ((pcinfo->output_scanline - 1) * (pcinfo->image_width)) / 2 + j ] = formPix;
							}
							break;
					}
				}
				jpeg_finish_decompress(pcinfo);
			}
			jpeg_destroy_decompress(pcinfo);
		}
	' inSmalltalk: [].! !

!JPEGReadWriter2Plugin methodsFor: 'primitives' stamp: 'John M McIntosh 1/4/2010 00:11'!
primJPEGWriteImage: aJPEGCompressStruct onByteArray: destination form: form quality: quality progressiveJPEG: progressiveFlag errorMgr: aJPEGErrorMgr2Struct

	| pcinfo pjerr buffer rowStride formBits formWidth formHeight formDepth i j formPix destinationSize pixPerWord formPitch formBitsSize formBitsOops |
	self export: true.
	self
		primitive: 'primJPEGWriteImageonByteArrayformqualityprogressiveJPEGerrorMgr'
		parameters: #(ByteArray ByteArray Form SmallInteger Boolean ByteArray).
 	self var: #pcinfo type: 'j_compress_ptr '.
 	self var: #pjerr type: 'error_ptr2 '.
	self var: #buffer type: 'JSAMPARRAY '.
	self var: #formBits type: 'unsigned * '.
	self var: #destinationSize type: 'unsigned int'.

	
		pcinfo := nil. pjerr := nil. buffer :=nil. rowStride := nil. formBits := nil. 
		formWidth := nil. formHeight := nil. formDepth := nil. i := nil. j := nil. formPix := nil. destinationSize := nil.
		pcinfo. pjerr. buffer. rowStride. formBits. formWidth. formHeight. formDepth. i. j. formPix. destinationSize.
	

	formBitsOops := interpreterProxy fetchPointer: 0 ofObject: form.
	formWidth := interpreterProxy fetchInteger: 1 ofObject: form.
	formHeight := interpreterProxy fetchInteger: 2 ofObject: form.
	formDepth := interpreterProxy fetchInteger: 3 ofObject: form.

	"Various parameter checks"
	self cCode: '
		interpreterProxy->success
			((interpreterProxy->stSizeOf(interpreterProxy->stackValue(5))) >= (sizeof(struct jpeg_compress_struct)));
		interpreterProxy->success
			((interpreterProxy->stSizeOf(interpreterProxy->stackValue(0))) >= (sizeof(struct error_mgr2))); 
		if (interpreterProxy->failed()) return null;
	' inSmalltalk: [].
	pixPerWord := 32 // formDepth.
	formPitch := formWidth + (pixPerWord-1) // pixPerWord * 4.
	formBitsSize := interpreterProxy byteSizeOf: formBitsOops.
	interpreterProxy success: 
		((interpreterProxy isWordsOrBytes: formBitsOops)
			and: [formBitsSize = (formPitch * formHeight)]).
	interpreterProxy failed ifTrue: [^ nil].
	formBits := interpreterProxy firstIndexableField: formBitsOops.
	self cCode: '
		destinationSize = interpreterProxy->stSizeOf(interpreterProxy->stackValue(4));
		pcinfo = (j_compress_ptr)aJPEGCompressStruct;
		pjerr = (error_ptr2)aJPEGErrorMgr2Struct;
		if (destinationSize) {
			pcinfo->err = jpeg_std_error(&pjerr->pub);
			pjerr->pub.error_exit = error_exit;
			if (setjmp(pjerr->setjmp_buffer)) {
				jpeg_destroy_compress(pcinfo);
				destinationSize = 0;
			}
			if (destinationSize) {
				jpeg_create_compress(pcinfo);
				jpeg_mem_dest(pcinfo, destination, &destinationSize);
				pcinfo->image_width = formWidth;
				pcinfo->image_height = formHeight;
				pcinfo->input_components = 3;
				pcinfo->in_color_space = JCS_RGB;
				jpeg_set_defaults(pcinfo);
				if (quality > 0)
					jpeg_set_quality (pcinfo, quality, 1);
				if (progressiveFlag)
					jpeg_simple_progression(pcinfo);
				jpeg_start_compress(pcinfo, TRUE);
				rowStride = formWidth * 3;

				/* Make a one-row-high sample array that will go away 
				  when done with image */
				buffer = (*(pcinfo->mem)->alloc_sarray)
					((j_common_ptr) pcinfo, JPOOL_IMAGE, rowStride, 1);

				while (pcinfo->next_scanline < pcinfo->image_height) {
					switch (formDepth) {
						case 32:
							for(i = 0, j = 1; i < rowStride; i +=3, j++) {
								formPix = formBits [ ((pcinfo->next_scanline) * formWidth) + j ];
								buffer[0][i] = (formPix >> 16) & 255;
								buffer[0][i+1] = (formPix >> 8) & 255;
								buffer[0][i+2] = formPix & 255;
							}
							break;
						case 16:
							for(i = 0, j = 1; i < rowStride; i +=6, j++) {
								formPix = formBits [ ((pcinfo->next_scanline) * formWidth) / 2 + j ];
								buffer[0][i] = (formPix >> 23) & 248;
								buffer[0][i+1] = (formPix >> 18) & 248;
								buffer[0][i+2] = (formPix >> 13) & 248;
								buffer[0][i+3] = (formPix >> 7) & 248;
								buffer[0][i+4] = (formPix >> 2) & 248;
								buffer[0][i+5] = (formPix << 3) & 248;
							}
							break;
					}
					(void) jpeg_write_scanlines(pcinfo, buffer, 1);

				}
				jpeg_finish_compress(pcinfo);
				jpeg_destroy_compress(pcinfo);
			}
		}
	' inSmalltalk: [].
	^(self cCode: 'destinationSize' inSmalltalk: [0])
		asOop: SmallInteger! !


!MIDIPlugin methodsFor: 'primitives' stamp: 'John M McIntosh 12/1/2009 21:40'!
primitiveMIDIGetPortName: portNum

	| portName sz nameObj namePtr |
	self var: #portName declareC: 'char portName[256]'.
	self var: #namePtr type: 'char * '.
	self primitive: 'primitiveMIDIGetPortName'
		parameters: #(SmallInteger).

	sz := self cCode: 'sqMIDIGetPortName(portNum, &portName, 255)'.
	nameObj := interpreterProxy instantiateClass: interpreterProxy classString indexableSize: sz.
	interpreterProxy failed ifTrue:[^nil].
	namePtr := nameObj asValue: String .
	self cCode: 'memcpy(namePtr, portName, sz)'.
	^nameObj! !


!RePlugin methodsFor: 'rcvr linkage' stamp: 'John M McIntosh 12/1/2009 21:40'!
rcvrExtraPtr

	|extraObj|
	self inline: true.
	extraObj := interpreterProxy fetchPointer: 3 ofObject: rcvr.
	(extraObj = (interpreterProxy nilObject))
		ifTrue: [^ self cCode: ' NULL'].
	^self 
		cCoerce:(interpreterProxy arrayValueOf: extraObj)
		to: 'int'.! !


!SoundPlugin methodsFor: 'primitives' stamp: 'John M McIntosh 12/1/2009 21:39'!
primitiveSoundInsertSamples: frameCount from: buf leadTime: leadTime 
	"Insert a buffer's worth of sound samples into the currently playing  
	buffer. Used to make a sound start playing as quickly as possible. The  
	new sound is mixed with the previously buffered sampled."
	"Details: Unlike primitiveSoundPlaySamples, this primitive always starts  
	with the first sample the given sample buffer. Its third argument  
	specifies the number of samples past the estimated sound output buffer  
	position the inserted sound should start. If successful, it returns the  
	number of samples inserted."
	| framesPlayed |
	self primitive: 'primitiveSoundInsertSamples'
		parameters: #(SmallInteger WordArray SmallInteger ).
	interpreterProxy success: frameCount <= (interpreterProxy slotSizeOf: buf cPtrAsOop).

	interpreterProxy failed
		ifFalse: [framesPlayed := self cCode: 'snd_InsertSamplesFromLeadTime(frameCount, buf, leadTime)'.
			interpreterProxy success: framesPlayed >= 0].
	^ framesPlayed asPositiveIntegerObj! !

!SoundPlugin methodsFor: 'primitives' stamp: 'John M McIntosh 12/1/2009 21:39'!
primitiveSoundPlaySamples: frameCount from: buf startingAt: startIndex 
	"Output a buffer's worth of sound samples."
	| framesPlayed |
	self primitive: 'primitiveSoundPlaySamples'
		parameters: #(SmallInteger WordArray SmallInteger ).
	interpreterProxy success: (startIndex >= 1 and: [startIndex + frameCount - 1 <= (interpreterProxy slotSizeOf: buf cPtrAsOop)]).

	interpreterProxy failed
		ifFalse: [framesPlayed := self cCode: 'snd_PlaySamplesFromAtLength(frameCount, buf, startIndex - 1)'.
			interpreterProxy success: framesPlayed >= 0].
	^ framesPlayed asPositiveIntegerObj! !

!SoundPlugin methodsFor: 'primitives' stamp: 'John M McIntosh 12/1/2009 21:39'!
primitiveSoundRecordSamplesInto: buf startingAt: startWordIndex 
	"Record a buffer's worth of 16-bit sound samples."
	| bufSizeInBytes samplesRecorded |
	self primitive: 'primitiveSoundRecordSamples'
		parameters: #(WordArray SmallInteger ).

	interpreterProxy failed
		ifFalse: [bufSizeInBytes := (interpreterProxy slotSizeOf: buf cPtrAsOop) * 4.
			interpreterProxy success: (startWordIndex >= 1 and: [startWordIndex - 1 * 2 < bufSizeInBytes])].

	interpreterProxy failed ifFalse: [samplesRecorded := self cCode: 'snd_RecordSamplesIntoAtLength(buf, startWordIndex - 1, bufSizeInBytes)'].
	^ samplesRecorded asPositiveIntegerObj! !

